// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`DescribeCustomKeyStores`](crate::operation::describe_custom_key_stores::builders::DescribeCustomKeyStoresFluentBuilder) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::operation::describe_custom_key_stores::builders::DescribeCustomKeyStoresFluentBuilder::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`custom_key_store_id(impl Into<String>)`](crate::operation::describe_custom_key_stores::builders::DescribeCustomKeyStoresFluentBuilder::custom_key_store_id) / [`set_custom_key_store_id(Option<String>)`](crate::operation::describe_custom_key_stores::builders::DescribeCustomKeyStoresFluentBuilder::set_custom_key_store_id):<br>required: **false**<br><p>Gets only information about the specified custom key store. Enter the key store ID.</p> <p>By default, this operation gets information about all custom key stores in the account and Region. To limit the output to a particular custom key store, provide either the <code>CustomKeyStoreId</code> or <code>CustomKeyStoreName</code> parameter, but not both.</p><br>
    ///   - [`custom_key_store_name(impl Into<String>)`](crate::operation::describe_custom_key_stores::builders::DescribeCustomKeyStoresFluentBuilder::custom_key_store_name) / [`set_custom_key_store_name(Option<String>)`](crate::operation::describe_custom_key_stores::builders::DescribeCustomKeyStoresFluentBuilder::set_custom_key_store_name):<br>required: **false**<br><p>Gets only information about the specified custom key store. Enter the friendly name of the custom key store.</p> <p>By default, this operation gets information about all custom key stores in the account and Region. To limit the output to a particular custom key store, provide either the <code>CustomKeyStoreId</code> or <code>CustomKeyStoreName</code> parameter, but not both.</p><br>
    ///   - [`limit(i32)`](crate::operation::describe_custom_key_stores::builders::DescribeCustomKeyStoresFluentBuilder::limit) / [`set_limit(Option<i32>)`](crate::operation::describe_custom_key_stores::builders::DescribeCustomKeyStoresFluentBuilder::set_limit):<br>required: **false**<br><p>Use this parameter to specify the maximum number of items to return. When this value is present, KMS does not return more than the specified number of items, but it might return fewer.</p><br>
    ///   - [`marker(impl Into<String>)`](crate::operation::describe_custom_key_stores::builders::DescribeCustomKeyStoresFluentBuilder::marker) / [`set_marker(Option<String>)`](crate::operation::describe_custom_key_stores::builders::DescribeCustomKeyStoresFluentBuilder::set_marker):<br>required: **false**<br><p>Use this parameter in a subsequent request after you receive a response with truncated results. Set it to the value of <code>NextMarker</code> from the truncated response you just received.</p><br>
    /// - On success, responds with [`DescribeCustomKeyStoresOutput`](crate::operation::describe_custom_key_stores::DescribeCustomKeyStoresOutput) with field(s):
    ///   - [`custom_key_stores(Option<Vec::<CustomKeyStoresListEntry>>)`](crate::operation::describe_custom_key_stores::DescribeCustomKeyStoresOutput::custom_key_stores): <p>Contains metadata about each custom key store.</p>
    ///   - [`next_marker(Option<String>)`](crate::operation::describe_custom_key_stores::DescribeCustomKeyStoresOutput::next_marker): <p>When <code>Truncated</code> is true, this element is present and contains the value to use for the <code>Marker</code> parameter in a subsequent request.</p>
    ///   - [`truncated(bool)`](crate::operation::describe_custom_key_stores::DescribeCustomKeyStoresOutput::truncated): <p>A flag that indicates whether there are more items in the list. When this value is true, the list in this response is truncated. To get more items, pass the value of the <code>NextMarker</code> element in thisresponse to the <code>Marker</code> parameter in a subsequent request.</p>
    /// - On failure, responds with [`SdkError<DescribeCustomKeyStoresError>`](crate::operation::describe_custom_key_stores::DescribeCustomKeyStoresError)
    pub fn describe_custom_key_stores(&self) -> crate::operation::describe_custom_key_stores::builders::DescribeCustomKeyStoresFluentBuilder {
        crate::operation::describe_custom_key_stores::builders::DescribeCustomKeyStoresFluentBuilder::new(self.handle.clone())
    }
}
