// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`ListResourceTags`](crate::operation::list_resource_tags::builders::ListResourceTagsFluentBuilder) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::operation::list_resource_tags::builders::ListResourceTagsFluentBuilder::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`key_id(impl Into<String>)`](crate::operation::list_resource_tags::builders::ListResourceTagsFluentBuilder::key_id) / [`set_key_id(Option<String>)`](crate::operation::list_resource_tags::builders::ListResourceTagsFluentBuilder::set_key_id):<br>required: **true**<br><p>Gets tags on the specified KMS key.</p> <p>Specify the key ID or key ARN of the KMS key.</p> <p>For example:</p> <ul>  <li>   <p>Key ID: <code>1234abcd-12ab-34cd-56ef-1234567890ab</code></p></li>  <li>   <p>Key ARN: <code>arn:aws:kms:us-east-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab</code></p></li> </ul> <p>To get the key ID and key ARN for a KMS key, use <code>ListKeys</code> or <code>DescribeKey</code>.</p><br>
    ///   - [`limit(i32)`](crate::operation::list_resource_tags::builders::ListResourceTagsFluentBuilder::limit) / [`set_limit(Option<i32>)`](crate::operation::list_resource_tags::builders::ListResourceTagsFluentBuilder::set_limit):<br>required: **false**<br><p>Use this parameter to specify the maximum number of items to return. When this value is present, KMS does not return more than the specified number of items, but it might return fewer.</p> <p>This value is optional. If you include a value, it must be between 1 and 50, inclusive. If you do not include a value, it defaults to 50.</p><br>
    ///   - [`marker(impl Into<String>)`](crate::operation::list_resource_tags::builders::ListResourceTagsFluentBuilder::marker) / [`set_marker(Option<String>)`](crate::operation::list_resource_tags::builders::ListResourceTagsFluentBuilder::set_marker):<br>required: **false**<br><p>Use this parameter in a subsequent request after you receive a response with truncated results. Set it to the value of <code>NextMarker</code> from the truncated response you just received.</p> <p>Do not attempt to construct this value. Use only the value of <code>NextMarker</code> from the truncated response you just received.</p><br>
    /// - On success, responds with [`ListResourceTagsOutput`](crate::operation::list_resource_tags::ListResourceTagsOutput) with field(s):
    ///   - [`tags(Option<Vec::<Tag>>)`](crate::operation::list_resource_tags::ListResourceTagsOutput::tags): <p>A list of tags. Each tag consists of a tag key and a tag value.</p><note>  <p>Tagging or untagging a KMS key can allow or deny permission to the KMS key. For details, see <a href="https://docs.aws.amazon.com/kms/latest/developerguide/abac.html">ABAC for KMS</a> in the <i>Key Management Service Developer Guide</i>.</p> </note>
    ///   - [`next_marker(Option<String>)`](crate::operation::list_resource_tags::ListResourceTagsOutput::next_marker): <p>When <code>Truncated</code> is true, this element is present and contains the value to use for the <code>Marker</code> parameter in a subsequent request.</p> <p>Do not assume or infer any information from this value.</p>
    ///   - [`truncated(bool)`](crate::operation::list_resource_tags::ListResourceTagsOutput::truncated): <p>A flag that indicates whether there are more items in the list. When this value is true, the list in this response is truncated. To get more items, pass the value of the <code>NextMarker</code> element in thisresponse to the <code>Marker</code> parameter in a subsequent request.</p>
    /// - On failure, responds with [`SdkError<ListResourceTagsError>`](crate::operation::list_resource_tags::ListResourceTagsError)
    pub fn list_resource_tags(&self) -> crate::operation::list_resource_tags::builders::ListResourceTagsFluentBuilder {
        crate::operation::list_resource_tags::builders::ListResourceTagsFluentBuilder::new(self.handle.clone())
    }
}
