// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq)]
pub struct CreateTokenOutput {
    /// <p>A bearer token to access AWS accounts and applications assigned to a user.</p>
    pub access_token: ::std::option::Option<::std::string::String>,
    /// <p>Used to notify the client that the returned token is an access token. The supported token type is <code>Bearer</code>.</p>
    pub token_type: ::std::option::Option<::std::string::String>,
    /// <p>Indicates the time in seconds when an access token will expire.</p>
    pub expires_in: i32,
    /// <p>A token that, if present, can be used to refresh a previously issued access token that might have expired.</p>
    /// <p>For more information about the features and limitations of the current IAM Identity Center OIDC implementation, see <i>Considerations for Using this Guide</i> in the <a href="https://docs.aws.amazon.com/singlesignon/latest/OIDCAPIReference/Welcome.html">IAM Identity Center OIDC API Reference</a>.</p>
    pub refresh_token: ::std::option::Option<::std::string::String>,
    /// <p>The <code>idToken</code> is not implemented or supported. For more information about the features and limitations of the current IAM Identity Center OIDC implementation, see <i>Considerations for Using this Guide</i> in the <a href="https://docs.aws.amazon.com/singlesignon/latest/OIDCAPIReference/Welcome.html">IAM Identity Center OIDC API Reference</a>.</p>
    /// <p>A JSON Web Token (JWT) that identifies who is associated with the issued access token.</p>
    pub id_token: ::std::option::Option<::std::string::String>,
    _request_id: Option<String>,
}
impl CreateTokenOutput {
    /// <p>A bearer token to access AWS accounts and applications assigned to a user.</p>
    pub fn access_token(&self) -> ::std::option::Option<&str> {
        self.access_token.as_deref()
    }
    /// <p>Used to notify the client that the returned token is an access token. The supported token type is <code>Bearer</code>.</p>
    pub fn token_type(&self) -> ::std::option::Option<&str> {
        self.token_type.as_deref()
    }
    /// <p>Indicates the time in seconds when an access token will expire.</p>
    pub fn expires_in(&self) -> i32 {
        self.expires_in
    }
    /// <p>A token that, if present, can be used to refresh a previously issued access token that might have expired.</p>
    /// <p>For more information about the features and limitations of the current IAM Identity Center OIDC implementation, see <i>Considerations for Using this Guide</i> in the <a href="https://docs.aws.amazon.com/singlesignon/latest/OIDCAPIReference/Welcome.html">IAM Identity Center OIDC API Reference</a>.</p>
    pub fn refresh_token(&self) -> ::std::option::Option<&str> {
        self.refresh_token.as_deref()
    }
    /// <p>The <code>idToken</code> is not implemented or supported. For more information about the features and limitations of the current IAM Identity Center OIDC implementation, see <i>Considerations for Using this Guide</i> in the <a href="https://docs.aws.amazon.com/singlesignon/latest/OIDCAPIReference/Welcome.html">IAM Identity Center OIDC API Reference</a>.</p>
    /// <p>A JSON Web Token (JWT) that identifies who is associated with the issued access token.</p>
    pub fn id_token(&self) -> ::std::option::Option<&str> {
        self.id_token.as_deref()
    }
}
impl ::std::fmt::Debug for CreateTokenOutput {
    fn fmt(&self, f: &mut ::std::fmt::Formatter<'_>) -> ::std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTokenOutput");
        formatter.field("access_token", &"*** Sensitive Data Redacted ***");
        formatter.field("token_type", &self.token_type);
        formatter.field("expires_in", &self.expires_in);
        formatter.field("refresh_token", &"*** Sensitive Data Redacted ***");
        formatter.field("id_token", &"*** Sensitive Data Redacted ***");
        formatter.field("_request_id", &self._request_id);
        formatter.finish()
    }
}
impl ::aws_types::request_id::RequestId for CreateTokenOutput {
    fn request_id(&self) -> Option<&str> {
        self._request_id.as_deref()
    }
}
impl CreateTokenOutput {
    /// Creates a new builder-style object to manufacture [`CreateTokenOutput`](crate::operation::create_token::CreateTokenOutput).
    pub fn builder() -> crate::operation::create_token::builders::CreateTokenOutputBuilder {
        crate::operation::create_token::builders::CreateTokenOutputBuilder::default()
    }
}

/// A builder for [`CreateTokenOutput`](crate::operation::create_token::CreateTokenOutput).
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default)]
pub struct CreateTokenOutputBuilder {
    pub(crate) access_token: ::std::option::Option<::std::string::String>,
    pub(crate) token_type: ::std::option::Option<::std::string::String>,
    pub(crate) expires_in: ::std::option::Option<i32>,
    pub(crate) refresh_token: ::std::option::Option<::std::string::String>,
    pub(crate) id_token: ::std::option::Option<::std::string::String>,
    _request_id: Option<String>,
}
impl CreateTokenOutputBuilder {
    /// <p>A bearer token to access AWS accounts and applications assigned to a user.</p>
    pub fn access_token(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.access_token = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>A bearer token to access AWS accounts and applications assigned to a user.</p>
    pub fn set_access_token(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.access_token = input;
        self
    }
    /// <p>A bearer token to access AWS accounts and applications assigned to a user.</p>
    pub fn get_access_token(&self) -> &::std::option::Option<::std::string::String> {
        &self.access_token
    }
    /// <p>Used to notify the client that the returned token is an access token. The supported token type is <code>Bearer</code>.</p>
    pub fn token_type(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.token_type = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>Used to notify the client that the returned token is an access token. The supported token type is <code>Bearer</code>.</p>
    pub fn set_token_type(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.token_type = input;
        self
    }
    /// <p>Used to notify the client that the returned token is an access token. The supported token type is <code>Bearer</code>.</p>
    pub fn get_token_type(&self) -> &::std::option::Option<::std::string::String> {
        &self.token_type
    }
    /// <p>Indicates the time in seconds when an access token will expire.</p>
    pub fn expires_in(mut self, input: i32) -> Self {
        self.expires_in = ::std::option::Option::Some(input);
        self
    }
    /// <p>Indicates the time in seconds when an access token will expire.</p>
    pub fn set_expires_in(mut self, input: ::std::option::Option<i32>) -> Self {
        self.expires_in = input;
        self
    }
    /// <p>Indicates the time in seconds when an access token will expire.</p>
    pub fn get_expires_in(&self) -> &::std::option::Option<i32> {
        &self.expires_in
    }
    /// <p>A token that, if present, can be used to refresh a previously issued access token that might have expired.</p>
    /// <p>For more information about the features and limitations of the current IAM Identity Center OIDC implementation, see <i>Considerations for Using this Guide</i> in the <a href="https://docs.aws.amazon.com/singlesignon/latest/OIDCAPIReference/Welcome.html">IAM Identity Center OIDC API Reference</a>.</p>
    pub fn refresh_token(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.refresh_token = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>A token that, if present, can be used to refresh a previously issued access token that might have expired.</p>
    /// <p>For more information about the features and limitations of the current IAM Identity Center OIDC implementation, see <i>Considerations for Using this Guide</i> in the <a href="https://docs.aws.amazon.com/singlesignon/latest/OIDCAPIReference/Welcome.html">IAM Identity Center OIDC API Reference</a>.</p>
    pub fn set_refresh_token(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.refresh_token = input;
        self
    }
    /// <p>A token that, if present, can be used to refresh a previously issued access token that might have expired.</p>
    /// <p>For more information about the features and limitations of the current IAM Identity Center OIDC implementation, see <i>Considerations for Using this Guide</i> in the <a href="https://docs.aws.amazon.com/singlesignon/latest/OIDCAPIReference/Welcome.html">IAM Identity Center OIDC API Reference</a>.</p>
    pub fn get_refresh_token(&self) -> &::std::option::Option<::std::string::String> {
        &self.refresh_token
    }
    /// <p>The <code>idToken</code> is not implemented or supported. For more information about the features and limitations of the current IAM Identity Center OIDC implementation, see <i>Considerations for Using this Guide</i> in the <a href="https://docs.aws.amazon.com/singlesignon/latest/OIDCAPIReference/Welcome.html">IAM Identity Center OIDC API Reference</a>.</p>
    /// <p>A JSON Web Token (JWT) that identifies who is associated with the issued access token.</p>
    pub fn id_token(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.id_token = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>The <code>idToken</code> is not implemented or supported. For more information about the features and limitations of the current IAM Identity Center OIDC implementation, see <i>Considerations for Using this Guide</i> in the <a href="https://docs.aws.amazon.com/singlesignon/latest/OIDCAPIReference/Welcome.html">IAM Identity Center OIDC API Reference</a>.</p>
    /// <p>A JSON Web Token (JWT) that identifies who is associated with the issued access token.</p>
    pub fn set_id_token(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.id_token = input;
        self
    }
    /// <p>The <code>idToken</code> is not implemented or supported. For more information about the features and limitations of the current IAM Identity Center OIDC implementation, see <i>Considerations for Using this Guide</i> in the <a href="https://docs.aws.amazon.com/singlesignon/latest/OIDCAPIReference/Welcome.html">IAM Identity Center OIDC API Reference</a>.</p>
    /// <p>A JSON Web Token (JWT) that identifies who is associated with the issued access token.</p>
    pub fn get_id_token(&self) -> &::std::option::Option<::std::string::String> {
        &self.id_token
    }
    pub(crate) fn _request_id(mut self, request_id: impl Into<String>) -> Self {
        self._request_id = Some(request_id.into());
        self
    }

    pub(crate) fn _set_request_id(&mut self, request_id: Option<String>) -> &mut Self {
        self._request_id = request_id;
        self
    }
    /// Consumes the builder and constructs a [`CreateTokenOutput`](crate::operation::create_token::CreateTokenOutput).
    pub fn build(self) -> crate::operation::create_token::CreateTokenOutput {
        crate::operation::create_token::CreateTokenOutput {
            access_token: self.access_token,
            token_type: self.token_type,
            expires_in: self.expires_in.unwrap_or_default(),
            refresh_token: self.refresh_token,
            id_token: self.id_token,
            _request_id: self._request_id,
        }
    }
}
impl ::std::fmt::Debug for CreateTokenOutputBuilder {
    fn fmt(&self, f: &mut ::std::fmt::Formatter<'_>) -> ::std::fmt::Result {
        let mut formatter = f.debug_struct("CreateTokenOutputBuilder");
        formatter.field("access_token", &"*** Sensitive Data Redacted ***");
        formatter.field("token_type", &self.token_type);
        formatter.field("expires_in", &self.expires_in);
        formatter.field("refresh_token", &"*** Sensitive Data Redacted ***");
        formatter.field("id_token", &"*** Sensitive Data Redacted ***");
        formatter.field("_request_id", &self._request_id);
        formatter.finish()
    }
}
